(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
	typeof define === 'function' && define.amd ? define(['exports'], factory) :
	(factory((global.formics = {})));
}(this, (function (exports) { 'use strict';

var FunctionsMixin = {
  methods: {
    f: function f(val) {
      return typeof val === 'function' ? val() : val;
    },
    // count this.f() for all passed props in an Object
    functions: function functions(obj) {
      var this$1 = this;
      if ( obj === void 0 ) obj = {};

      var props = {};
      for (var i = 0, list = Object.entries(obj); i < list.length; i += 1) {
        var ref = list[i];
        var key = ref[0];
        var val = ref[1];

        props[key] = this$1.f(val);
      }
      return props;
    },
    // count this.f() for all passed props in an Array
    functionsArray: function functionsArray(arr) {
      var this$1 = this;
      if ( arr === void 0 ) arr = [];

      return arr.map(function (val) {
        return this$1.f(val);
      });
    }
  }
};

var FormicsButtons = { render: function () {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c(_vm.layout, { tag: "component", attrs: { "slot": "buttons", "schema": _vm.computedButtons, "custom": _vm.custom }, slot: "buttons" }, _vm._l(_vm.computedButtons, function (button, key) {
      return _c('formics-button', _vm._b({ key: key, attrs: { "slot": key, "type": key === 'submit' ? 'submit' : 'button' }, on: { "click": function ($event) {
            _vm.onClick(key);
          } }, slot: key }, 'formics-button', _vm.computedButton(button), false));
    }));
  }, staticRenderFns: [],
  mixins: [FunctionsMixin],
  props: {
    settings: Object,
    layout: String,
    buttons: {
      type: Object,
      default: function default$1() {
        return {
          submit: {
            label: 'submit'
          }
        };
      }
    },
    custom: {
      type: Object,
      default: function default$2() {
        return {};
      }
    }
  },
  computed: {
    computedButtons: function computedButtons() {
      var buttons = {};
      Object.entries(this.buttons).forEach(function (ref) {
        var key = ref[0];
        var val = ref[1];

        if (typeof val === 'string') {
          buttons[key] = {
            label: val
          };
        } else {
          buttons[key] = val;
        }
      });
      return buttons;
    }
  },
  methods: {
    computedButton: function computedButton(button) {
      var this$1 = this;

      var obj = {};
      Object.entries(button).forEach(function (ref) {
        var key = ref[0];
        var val = ref[1];

        // we change `custom` to `customProp` so that we can use `custom` as a field property exposed to templates
        if (key !== 'custom') {
          obj[key] = this$1.f(val);
        } else {
          obj.customProp = this$1.f(val) || {};
        }
      });
      return obj;
    },
    onClick: function onClick(name) {
      this.$emit('event', {
        name: name
      });
    }
  }
};

var CheckboxMixin = {
  methods: {
    // checks if checkbox key should be disabled when the limit is hit
    checkboxLimit: function checkboxLimit(option) {
      if (this.limit) {
        console.log('limit: ' + this.limit);
        console.log('length: ' + this.fieldModel.length);
        console.log('fieldModel: ' + JSON.stringify(this.fieldModel));
        console.log('comparison: ' + this.fieldModel.length >= this.limit);
        console.log('indexOf: ' + this.fieldModel.indexOf(option.value));
        console.log('value:' + option.value);
        console.log('overall:' + this.fieldModel.length >= this.limit && this.fieldModel.indexOf(option.value) === -1);
        return this.fieldModel.length >= this.limit && this.fieldModel.indexOf(option.value) === -1;
      }
    }
  }
};

var CustomMixin = {
  props: {
    // we're naming this customProp so that we can save custom name for templates
    customProp: {
      type: Object,
      default: function default$1() {
        return {};
      }
    }
  },
  computed: {
    // custom options for particular field
    custom: function custom() {
      var this$1 = this;

      var custom = {};
      if (this.root) {
        // custom options for single element
        custom = Object.assign({}, this.defaults, this.functions(this.customProp));
      } else {
        // custom options for multiple elements
        Object.entries(this.defaults || {}).forEach(function (ref) {
          var key = ref[0];
          var val = ref[1];

          custom[key] = Object.assign({}, val, this$1.functions(this$1.customProp[key]));
        });
      }
      return custom;
    }
  }
};

var EmitMixin = {
  props: {
    commit: String,
    dispatch: String,
    event: {
      type: String,
      default: 'change'
    }
  },
  methods: {
    emit: function emit() {
      if (this.$store) {
        this.commitMutation();
        this.dispatchAction();
      }
      if (this.name !== 'form') {
        this.emitEvent(this.event);
      }
      // i guess at some point i decided that groups don't use that
      if (this.isField) {
        this.emitEvent(this.settings.event);
      }
      this.$emit('input', this.fieldModel);
    },
    commitMutation: function commitMutation() {
      if (this.commit) {
        this.$store.commit(this.commit, this.fieldModel);
      }
    },
    dispatchAction: function dispatchAction() {
      if (this.dispatch) {
        this.$store.dispatch(this.dispatch, {
          field: this.name,
          model: this.fieldModel
        });
      }
    },
    emitEvent: function emitEvent(event) {
      if (event) {
        this.$emit('event', {
          name: event,
          field: this.name,
          model: this.fieldModel,
          isValid: !this.invalid
        });
      }
    }
  }
};

var ModelMixin = {
  props: {
    model: {
      required: true
    },
    // is that needed?
    mask: {
      type: String,
      default: ''
    },
    limit: Number,
    default: {
      required: false
    }
  },
  data: function data() {
    return {
      fieldModel: this.model
    };
  },
  watch: {
    model: function model(val) {
      this.fieldModel = val;
      // this.updateCheckbox()
      this.$emit('touch', this.name);
    },
    fieldModel: function fieldModel() {
      this.emit(this.type + ': ' + JSON.stringify(this.fieldModel));
    }
  },
  created: function created() {
    this.fieldModel = this.model;
  }
};

var OptionsMixin = {
  props: {
    // we're calling this optionsProp so that we can save options name for templates
    optionsProp: {
      type: [Object, Array],
      default: function default$1() {
        return {};
      }
    }
  },
  watch: {
    // filters out keys that are not used by schema anymore
    // should it be done for select too? probably not because select options are often dynamic / async
    options: function options() {
      var this$1 = this;

      if (this.type === 'checkbox') {
        this.fieldModel = this.options.filter(function (option) { return this$1.fieldModel.indexOf(option.value) > -1; });
      }
    }
  },
  computed: {
    options: function options() {
      var this$1 = this;

      var result = [];
      var options = this.f(this.optionsProp);
      // array
      if (Array.isArray(options)) {
        console.log('LOL ARRAY: ' + JSON.stringify(options));
        var optionsArray = this.functionsArray(options);
        result = optionsArray.map(function (val) {
          // collection
          if (typeof val === 'object') {
            console.log('NYA OBJECT: ' + JSON.stringify(val));
            return Object.assign({}, this$1.functions(val));
          } else {
            console.log('NYA VALUE: ' + JSON.stringify(val));
            return { text: val, value: val };
          }
        });
        // object
      } else {
        console.log('LOL OBJECT: ' + JSON.stringify(options));
        var optionsObject = this.functions(options);
        result = Object.keys(optionsObject).map(function (key) {
          var val = optionsObject[key];
          console.log('optionsProp for label: ' + key + ': ' + val);
          // nested object
          if (typeof val === 'object') {
            return Object.assign({}, this$1.functions(val), { text: key });
          } else {
            return { value: val, text: key };
          }
        });
      }
      return this.functionsArray(result);
    }
  },
  methods: {
    // bindings for iterated fields like radio, checkbox, switch, select
    getOptionBindings: function getOptionBindings(option, text, value) {
      if ( text === void 0 ) text = 'text';
      if ( value === void 0 ) value = 'value';

      var bindings = Object.assign({}, this.custom.field, option);
      console.log('getOptions before: ' + JSON.stringify(bindings));
      if (text !== 'text') {
        bindings[text] = bindings.text;
        delete bindings.text;
      }
      if (value !== 'value') {
        bindings[value] = bindings.value;
        delete bindings.value;
      }
      console.log('getOptions after: ' + JSON.stringify(bindings));
      return bindings;
    }
  }
};

var PasswordMixin = {
  data: function data() {
    return {
      showPassword: false
    };
  },
  computed: {
    // dynamically change type between password and text for password inputs
    getInputType: function getInputType() {
      if (this.type === 'password') {
        return this.showPassword ? 'text' : 'password';
      } else {
        return this.type;
      }
    }
  }
};

var TextsMixin = {
  props: {
    placeholder: String,
    label: String,
    hint: String
  },
  computed: {
    getLabel: function getLabel() {
      return this.getText('labels', this.label || this.name);
    },
    getPlaceholder: function getPlaceholder() {
      return this.placeholder ? this.getText('placeholders', this.placeholder) : '';
    },
    getHint: function getHint() {
      return this.hint ? this.getText('hint', this.hint) : '';
    }
  },
  methods: {
    getText: function getText(category, text, params) {
      // we declare labels, placeholders and errors separately because this way they're more flexible and reusable across multiple forms
      return this.$i18n ? this.$i18n.t('formics.' + category + '.' + text, params) : text;
    }
  }
};

var ValidationMixin = {
  props: {
    validations: {
      type: Object,
      default: function default$1() {
        return {};
      }
    },
    // is that still needed?
    v: {
      type: Object,
      default: function default$2() {
        return {};
      }
    },
    messages: {
      type: Object,
      default: function default$3() {
        return {};
      }
    }
  },
  computed: {
    invalid: function invalid() {
      return typeof this.$v === 'undefined' ? false : this.$v.$invalid;
    }
  },
  watch: {
    $v: function $v(val) {
      this.$emit('touch', this.name);
    }
  },
  methods: {
    getErrors: function getErrors(v) {
      var this$1 = this;

      var arr = [];
      // are there any validation rules
      if (typeof v === 'object') {
        // is any validator invalid
        if (v.$error) {
          for (var i = 0, list = Object.entries(v.$params); i < list.length; i += 1) {
            // is validator invalid and not a promise
            var ref = list[i];
            var validator = ref[0];
            var params = ref[1];

            if (!v[validator] && !v.$pending) {
              if (this$1.$i18n) {
                arr.push(this$1.$i18n.t('formics.validation.' + validator, params));
              } else {
                arr.push(this$1.messages[validator] || 'error message missing for key: ' + validator);
              }
            }
          }
        }
      }
      // return array of errors or empty array
      return arr;
    }
  }
};

var FormicsMixin = {
  mixins: [CheckboxMixin, CustomMixin, EmitMixin, FunctionsMixin, ModelMixin, OptionsMixin, PasswordMixin, TextsMixin, ValidationMixin],
  props: {
    field: {
      type: Object,
      default: function default$1() {
        return {};
      }
    },
    settings: Object,
    components: {
      type: Object,
      default: function default$2() {
        return {};
      }
    },
    schema: Object,
    disabled: Boolean,
    required: Boolean,
    wrapper: {
      type: String,
      default: 'div'
    },
    layout: [String, Object],
    state: String,
    name: {
      type: String,
      required: true
    },
    type: String,
    i18n: Array
  },
  computed: {
    isField: function isField() {
      return this.type !== 'group';
    }
  },
  methods: {
    isActive: function isActive(active) {
      return typeof active === 'undefined' ? true : this.f(active);
    },
    areEqual: function areEqual(left, right) {
      return JSON.stringify(left) === JSON.stringify(right);
    }
  }
};

var FormicsTypes = {};

function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var params = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) {
  var arguments$1 = arguments;

  for (var i = 1; i < arguments.length; i++) {
    var source = arguments$1[i];for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }return target;
};

exports.pushParams = pushParams;
exports.popParams = popParams;
exports.withParams = withParams;

var stack = [];

// exported for tests
var target = exports.target = null;
var _setTarget = exports._setTarget = function _setTarget(x) {
  exports.target = target = x;
};

function pushParams() {
  if (target !== null) {
    stack.push(target);
  }
  exports.target = target = {};
}

function popParams() {
  var lastTarget = target;
  var newTarget = exports.target = target = stack.pop() || null;
  if (newTarget) {
    if (!Array.isArray(newTarget.$sub)) {
      newTarget.$sub = [];
    }
    newTarget.$sub.push(lastTarget);
  }
  return lastTarget;
}

function addParams(params) {
  if (typeof params === 'object' && !Array.isArray(params)) {
    exports.target = target = _extends({}, target, params);
  } else {
    throw new Error('params must be an object');
  }
}

function withParamsDirect(params, validator) {
  return withParamsClosure(function (add) {
    return function () {
      var arguments$1 = arguments;

      add(params);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments$1[_key];
      }

      return validator.apply(this, args);
    };
  });
}

function withParamsClosure(closure) {
  var validator = closure(addParams);
  return function () {
    var arguments$1 = arguments;

    pushParams();
    try {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments$1[_key2];
      }

      return validator.apply(this, args);
    } finally {
      popParams();
    }
  };
}

function withParams(paramsOrClosure, maybeValidator) {
  if (typeof paramsOrClosure === 'object' && maybeValidator !== undefined) {
    return withParamsDirect(paramsOrClosure, maybeValidator);
  }
  return withParamsClosure(paramsOrClosure);
}
});

unwrapExports(params);
var params_1 = params.pushParams;
var params_2 = params.popParams;
var params_3 = params.withParams;
var params_4 = params.target;
var params_5 = params._setTarget;

var withParams_1 = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
/* istanbul ignore next */
var withParams = params.withParams;

exports.default = withParams;
});

unwrapExports(withParams_1);

var common = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.regex = exports.ref = exports.len = exports.req = exports.withParams = undefined;



var _withParams2 = _interopRequireDefault(withParams_1);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

exports.withParams = _withParams2.default;

// "required" core, used in almost every validator to allow empty values

var req = exports.req = function req(value) {
  if (Array.isArray(value)) { return !!value.length; }
  if (value === undefined || value === null || value === false) {
    return false;
  }

  if (typeof value === 'object') {
    for (var _ in value) {
      return true;
    }return false;
  }

  return !!String(value).length;
};

// get length in type-agnostic way
var len = exports.len = function len(value) {
  if (Array.isArray(value)) { return value.length; }
  if (typeof value === 'object') {
    return Object.keys(value).length;
  }
  return String(value).length;
};

// resolve referenced value
var ref = exports.ref = function ref(reference, vm, parentVm) {
  return typeof reference === 'function' ? reference.call(vm, parentVm) : parentVm[reference];
};

// regex based validator template
var regex = exports.regex = function regex(type, expr) {
  return (0, _withParams2.default)({ type: type }, function (value) {
    return !req(value) || expr.test(value);
  });
};
});

unwrapExports(common);
var common_1 = common.regex;
var common_2 = common.ref;
var common_3 = common.len;
var common_4 = common.req;
var common_5 = common.withParams;

var alpha = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = (0, common.regex)('alpha', /^[a-zA-Z]*$/);
});

unwrapExports(alpha);

var alphaNum = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = (0, common.regex)('alphaNum', /^[a-zA-Z0-9]*$/);
});

unwrapExports(alphaNum);

var numeric = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = (0, common.regex)('numeric', /^[0-9]*$/);
});

unwrapExports(numeric);

var between = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function (min, max) {
  return (0, common.withParams)({ type: 'between', min: min, max: max }, function (value) {
    return !(0, common.req)(value) || !/\s/.test(value) && +min <= +value && +max >= +value;
  });
};
});

unwrapExports(between);

var email = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



var emailRegex = /(^$|^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$)/;

exports.default = (0, common.regex)('email', emailRegex);
});

unwrapExports(email);

var maxLength = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function (length) {
  return (0, common.withParams)({ type: 'maxLength', max: length }, function (value) {
    return !(0, common.req)(value) || (0, common.len)(value) <= length;
  });
};
});

unwrapExports(maxLength);

var minLength = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function (length) {
  return (0, common.withParams)({ type: 'minLength', min: length }, function (value) {
    return !(0, common.req)(value) || (0, common.len)(value) >= length;
  });
};
});

unwrapExports(minLength);

var required = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = (0, common.withParams)({ type: 'required' }, common.req);
});

unwrapExports(required);

var requiredIf = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function (prop) {
  return (0, common.withParams)({ type: 'requiredIf', prop: prop }, function (value, parentVm) {
    return (0, common.ref)(prop, this, parentVm) ? (0, common.req)(value) : true;
  });
};
});

unwrapExports(requiredIf);

var requiredUnless = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function (prop) {
  return (0, common.withParams)({ type: 'requiredUnless', prop: prop }, function (value, parentVm) {
    return !(0, common.ref)(prop, this, parentVm) ? (0, common.req)(value) : true;
  });
};
});

unwrapExports(requiredUnless);

var sameAs = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function (equalTo) {
  return (0, common.withParams)({ type: 'sameAs', eq: equalTo }, function (value, parentVm) {
    return value === (0, common.ref)(equalTo, this, parentVm);
  });
};
});

unwrapExports(sameAs);

var url = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



var urlRegex = /^(?:(?:https?|ftp):\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:[/?#]\S*)?$/;

exports.default = (0, common.regex)('url', urlRegex);
});

unwrapExports(url);

var or = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function () {
  var arguments$1 = arguments;

  for (var _len = arguments.length, validators = Array(_len), _key = 0; _key < _len; _key++) {
    validators[_key] = arguments$1[_key];
  }

  return (0, common.withParams)({ type: 'or' }, function () {
    var arguments$1 = arguments;

    var _this = this;

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments$1[_key2];
    }

    return validators.length > 0 && validators.reduce(function (valid, fn) {
      return valid || fn.apply(_this, args);
    }, false);
  });
};
});

unwrapExports(or);

var and = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});



exports.default = function () {
  var arguments$1 = arguments;

  for (var _len = arguments.length, validators = Array(_len), _key = 0; _key < _len; _key++) {
    validators[_key] = arguments$1[_key];
  }

  return (0, common.withParams)({ type: 'and' }, function () {
    var arguments$1 = arguments;

    var _this = this;

    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments$1[_key2];
    }

    return validators.length > 0 && validators.reduce(function (valid, fn) {
      return valid && fn.apply(_this, args);
    }, true);
  });
};
});

unwrapExports(and);

var validators = createCommonjsModule(function (module, exports) {
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.and = exports.or = exports.url = exports.sameAs = exports.requiredUnless = exports.requiredIf = exports.required = exports.minLength = exports.maxLength = exports.email = exports.between = exports.numeric = exports.alphaNum = exports.alpha = undefined;



var _alpha2 = _interopRequireDefault(alpha);



var _alphaNum2 = _interopRequireDefault(alphaNum);



var _numeric2 = _interopRequireDefault(numeric);



var _between2 = _interopRequireDefault(between);



var _email2 = _interopRequireDefault(email);



var _maxLength2 = _interopRequireDefault(maxLength);



var _minLength2 = _interopRequireDefault(minLength);



var _required2 = _interopRequireDefault(required);



var _requiredIf2 = _interopRequireDefault(requiredIf);



var _requiredUnless2 = _interopRequireDefault(requiredUnless);



var _sameAs2 = _interopRequireDefault(sameAs);



var _url2 = _interopRequireDefault(url);



var _or2 = _interopRequireDefault(or);



var _and2 = _interopRequireDefault(and);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : { default: obj };
}

exports.alpha = _alpha2.default;
exports.alphaNum = _alphaNum2.default;
exports.numeric = _numeric2.default;
exports.between = _between2.default;
exports.email = _email2.default;
exports.maxLength = _maxLength2.default;
exports.minLength = _minLength2.default;
exports.required = _required2.default;
exports.requiredIf = _requiredIf2.default;
exports.requiredUnless = _requiredUnless2.default;
exports.sameAs = _sameAs2.default;
exports.url = _url2.default;
exports.or = _or2.default;
exports.and = _and2.default;
});

unwrapExports(validators);
var validators_1 = validators.and;
var validators_2 = validators.or;
var validators_3 = validators.url;
var validators_4 = validators.sameAs;
var validators_5 = validators.requiredUnless;
var validators_6 = validators.requiredIf;
var validators_7 = validators.required;
var validators_8 = validators.minLength;
var validators_9 = validators.maxLength;
var validators_10 = validators.email;
var validators_11 = validators.between;
var validators_12 = validators.numeric;
var validators_13 = validators.alphaNum;
var validators_14 = validators.alpha;

var FormicsGroup = { render: function () {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c(_vm.layout || _vm.groupLayout, { tag: "component", attrs: { "schema": _vm.groupSchema, "custom": _vm.custom } }, [_vm._l(_vm.groupSchema, function (field, key) {
      return _vm.isActive(field) ? [field.type === 'group' ? [_c('formics-group', _vm._b({ key: key, attrs: { "slot": key, "name": key, "model": _vm.groupModel[key], "v": _vm.$v.groupModel[key] || {}, "messages": _vm.messages, "settings": _vm.settings, "validations": _vm.groupValidations[key] || {}, "schema": _vm.groupSchema[key].schema, "is-valid": _vm.isValid, "group-layout": "settings.group.layout" }, on: { "input": function (val) { return _vm.set(key, val); }, "touch": _vm.touch, "event": _vm.passEvent, "validation": _vm.updateGroupValidations }, slot: key }, 'formics-group', field, false))] : [_c(field.component, _vm._b({ key: key, tag: "component", attrs: { "slot": key, "name": key, "model": _vm.groupModel[key], "v": _vm.$v.groupModel[key] || {}, "messages": _vm.messages, "settings": _vm.settings }, on: { "input": function (val) { return _vm.set(key, val); }, "touch": _vm.touch, "event": _vm.passEvent }, slot: key }, 'component', _vm.computedField(key), false))]] : _vm._e();
    })], 2);
  }, staticRenderFns: [],
  name: 'FormicsGroup',
  mixins: [FormicsMixin],
  props: {
    isValid: Boolean,
    default: false,
    groupLayout: {
      type: String,
      default: 'FormicsGroupLayout'
    }
  },
  data: function data() {
    return {
      groupModel: {},
      groupSchema: {},
      groupValidations: {},
      oldSchema: {}
    };
  },
  created: function created() {
    this.updateSchema();
    this.updateModel(this.model);
    this.$emit('input', this.groupModel);
  },
  watch: {
    schema: {
      handler: function handler(val, oldVal) {
        this.updateSchema();
        this.updateModel(this.groupModel);
        this.$emit('input', this.groupModel);
      },
      deep: true
    },
    groupSchema: {
      handler: function handler(val, oldVal) {
        this.oldSchema = oldVal;
        this.updateValidations('watcher schema');
      },
      deep: true
    },
    model: {
      handler: function handler(val) {
        if (!this.areEqual(val, this.groupModel)) {
          this.updateModel(val);
          this.$emit('input', this.groupModel);
        }
      },
      deep: true
    },
    $v: {
      handler: function handler(val) {
        this.$emit('updateValidationState', this.$v);
      },
      deep: true
    },
    // this is a workaround because directly watching or computing this.$v.groupModel.$invalid
    // results with SSR issues (different errors amount on the server and client)
    groupModel: {
      handler: function handler(val) {
        // only main group should emit updateIsValid when it changes locally
        if (this.name === 'form' && this.isValid !== !this.$v.groupModel.$invalid) {
          this.$emit('update', {
            property: 'isValid',
            payload: !this.$v.groupModel.$invalid
          });
        }
        this.$emit('input', this.groupModel);
      },
      deep: true
    }
  },
  methods: {
    // one of child fields got updated
    set: function set(key, newModel) {
      var oldModel = this.groupModel[key];
      if (!this.areEqual(newModel, oldModel)) {
        this.$set(this.groupModel, key, newModel);
        this.emit('set');
      }
    },
    // touch event for vuelidate
    touch: function touch(name) {
      if (this.$v) {
        if (this.$v.groupModel[name]) {
          this.$v.groupModel[name].$touch();
          this.$emit('touch', name);
        }
      }
    },
    updateSchema: function updateSchema() {
      var localSchema = {};
      Object.entries(this.schema).forEach(function (ref) {
        var key = ref[0];
        var val = ref[1];

        var obj = typeof val === 'string' ? { type: val } : val; // for fields defined as string
        obj.type = obj.type || 'text';
        obj.component = FormicsTypes[obj.type].component;
        // update default model
        if (typeof obj.default !== typeof FormicsTypes[obj.type].default) {
          obj.default = FormicsTypes[obj.type].default;
        }
        if (typeof obj.model === 'undefined') {
          obj.model = obj.default;
        }
        localSchema[key] = obj;
      });
      this.groupSchema = localSchema;
    },
    // separate loop makes sure that the unused keys get removed from this.model
    updateModel: function updateModel(model) {
      var localModel = {};
      Object.entries(this.groupSchema).forEach(function (ref) {
        var key = ref[0];
        var val = ref[1];

        localModel[key] = model.hasOwnProperty(key) ? model[key] : val.default;
      });
      this.groupModel = localModel;
    },
    // separate loop makes sure that the unused keys get removed
    updateValidations: function updateValidations(val) {
      var this$1 = this;

      // let localValidations = Object.keys(this.groupValidations).length > 0 ? this.groupValidations : this.validations
      var localValidations = {};
      Object.entries(this.groupSchema).forEach(function (ref) {
        var key = ref[0];
        var val = ref[1];

        if (this$1.validations.hasOwnProperty(key) || val.validators) {
          if (this$1.f(val.required)) {
            val.validators.required = validators_7;
          }
          localValidations[key] = Object.assign({}, this$1.validations[key] || {}, val.validators || {});
        }
      });
      this.groupValidations = localValidations;
      this.$emit('update', {
        property: 'validations',
        payload: this.groupValidations
      });
    },
    updateGroupValidations: function updateGroupValidations(val) {
      this.$set(this.groupValidations, this.name, val);
    },
    // is field invalid (for errors slot)
    isInvalid: function isInvalid(key) {
      if (this.$v.groupModel.hasOwnProperty(key)) {
        return this.$v.groupModel[key].$invalid;
      } else {
        return false;
      }
    },
    // pass the events further to the top
    passEvent: function passEvent(event) {
      if (this.name !== 'form') {
        event.field = this.name + '.' + event.field;
      }
      if (event.field !== 'form') {
        console.log('event.field = ' + event.field);
        this.$emit('event', event);
      }
    },
    // prepare field props for v-bind
    computedField: function computedField(field) {
      var this$1 = this;

      var localField = {};
      Object.entries(this.groupSchema[field]).forEach(function (ref) {
        var key = ref[0];
        var val = ref[1];

        // we change `custom` to `customProp` so that we can use `custom` as a field property exposed to templates
        if (key === 'custom') {
          localField.customProp = this$1.f(val) || {};
        } else if (key === 'options') {
          localField.optionsProp = this$1.f(val) || [];
        } else {
          localField[key] = this$1.f(val);
        }
      });
      return localField;
    }
  },
  // vuelidate magic happens here
  validations: function validations() {
    return {
      groupModel: this.groupValidations || {}
    };
  }
};

var FormicsForm = { render: function () {
    var _vm = this;var _h = _vm.$createElement;var _c = _vm._self._c || _h;return _c('form', { on: { "submit": function ($event) {
          $event.preventDefault();_vm.submit($event);
        } } }, [_c('formics-group', { key: "form", attrs: { "slot": "fields", "name": "form", "type": "group", "model": _vm.model, "settings": _vm.computedSettings, "validations": _vm.validations, "schema": _vm.schema, "is-valid": _vm.isValid, "group-layout": "FormicsFormLayout" }, on: { "input": _vm.onInput, "update": function (val) { return _vm.emitUpdate(val); }, "event": _vm.passEvent }, slot: "fields" }), _vm._v(" "), _c('formics-buttons', { attrs: { "layout": _vm.computedSettings.buttons.layout || 'FormicsButtonsLayout', "buttons": _vm.buttons, "custom": _vm.computedSettings.buttons.custom || {} }, on: { "event": _vm.passEvent } })], 1);
  }, staticRenderFns: [],
  name: 'FormicsForm',
  components: {
    FormicsButtons: FormicsButtons,
    FormicsGroup: FormicsGroup
  },
  props: {
    settings: {
      type: Object,
      default: function default$1() {
        return {};
      }
    },
    schema: {
      type: Object,
      required: true
    },
    model: {
      type: Object,
      default: function default$2() {
        return {};
      }
    },
    buttons: {
      type: Object,
      default: function default$3() {
        return {};
      }
    },
    // optional vuelidate schema
    validations: {
      type: Object,
      default: function default$4() {
        return {};
      }
    },
    // optional read-only property
    isValid: {
      type: Boolean,
      default: false
    }
  },
  computed: {
    // default values for all settings
    computedSettings: function computedSettings() {
      var settings = this.settings;
      var arr = ['form', 'group', 'fields', 'buttons', 'messages'];
      arr.forEach(function (key) {
        settings[key] = settings[key] || {};
      });
      return settings;
    }
  },
  methods: {
    // emit event back to component if a button was clicked with no callback provided
    // argument is the key of in the buttons object
    // update model in the parent
    onInput: function onInput(val) {
      if (JSON.stringify(val) !== JSON.stringify(this.model)) {
        this.$emit('input', val);
      }
    },
    // emit custom update event for `.sync` purposes
    emitUpdate: function emitUpdate(ref) {
      var property = ref.property;
      var payload = ref.payload;

      this.$emit('update:' + property, payload);
    },
    // pass custom events
    passEvent: function passEvent(event) {
      var name = event.name;
      delete event.name;
      this.$emit(name, event);
    },
    submit: function submit() {
      console.log('submit');
    }
  }
};

var LayoutMixin = {
  props: {
    schema: {
      type: Object,
      default: function default$1() {
        return {};
      }
    },
    custom: {
      type: Object,
      default: function default$2() {
        return {};
      }
    }
  },
  methods: {
    f: function f(val) {
      return typeof val === 'function' ? val() : val;
    }
  }
};

var ButtonMixin = {
  mixins: [CustomMixin, FunctionsMixin],
  props: {
    label: String,
    callback: Function,
    disabled: {
      required: false
    }
  },
  data: function data() {
    return {
      root: true,
      defaults: {}
    };
  },
  methods: {
    // emit an event back to FormicsForm or trigger the callback function if provided
    action: function action() {
      typeof this.callback === 'function' ? this.callback() : this.$emit('click');
    }
  }
};

// Install the components
var install = function (Vue, Components) {
  Vue.component('FormicsForm', FormicsForm);

  Object.keys(Components).forEach(function (key) {
    Vue.component(key, Components[key]);
  });
};

var Formics = {
  install: install
};

// Auto-install
if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(Formics);
}

exports.Formics = Formics;
exports.ButtonMixin = ButtonMixin;
exports.LayoutMixin = LayoutMixin;
exports.FormicsMixin = FormicsMixin;
exports.FormicsTypes = FormicsTypes;
exports.FormicsForm = FormicsForm;

Object.defineProperty(exports, '__esModule', { value: true });

})));
