# Alternative Libraries

### Vue-Form-Generator

[Vue-Form-Generator](https://github.com/icebob/vue-form-generator) is the most popular form generator for Vue.js at the moment. It uses array based schema, it's own validation solution and a set of templates based on Bootstrap. You can use one of two builds - basic with most commonly used fields and full with all the bells and whistles the library has to offer. Both can be extended with your custom fields.

Vue-Form-Generator has nice [documentation](https://icebob.gitbooks.io/vueformgenerator/content) on Gitbooks. Unlike Formics, it's fully tested, stable and production ready, so consider using it if that's your requirement.

### Vue-SimpleForm

[Vue-SimpleForm](https://github.com/blocka/vue-simpleform) is not a form generator but a small library that helps you to get rid of the common boilerplate. It takes care of the most annoying parts of writing forms, while still leaving you the full control over your templates. It's heavily influenced by [Formik](https://github.com/jaredpalmer/formik), a popular forms solution in React ecosystem.

Rather than writing a schema, you pass your form with its fields as a scoped slot to `<SimpleForm>` wrapper component. If you fancy that way, by all means give it a go. It's pretty easy to use, but if you have additional questions, you can often find the author on [chat.vuejs.org](https://chat.vuejs.org).

### Vue-Formly

[Vue-Formly](https://github.com/formly-js/vue-formly) takes obvious inspiration from [Angular-Formly](http://angular-formly.com). It's an oldest available form generator for Vue, written originally for Vue 1, but fully working with Vue 2 now. 

It allows you to write your custom set of templates, out of the box there's also a set of components for Bootstarp, available as a separate library. Just like Vue-Form-Generator, it uses its own validation system. Check out more in the [documentation](https://matt-sanders.gitbooks.io/vue-formly).

### Vue-Form-Wizard

[Vue-Form-Wizard](https://github.com/cristijora/vue-form-wizard) is a different kind of forms related library. It lets you to create a multiple step form wizard, commonly used in online shops and other commercial webapps.

You can use it with UI and validation libraries of your choice, it also provides support for Vue-Router. It comes with comprehensive [documentation](https://cristijora.github.io/vue-form-wizard) and in case of problems, you can ask the author about it on [chat.vuejs.org](https://chat.vuejs.org).