# Settings

Using `settings` object you can configure your form to fit your specific needs.

### Layouts

Settings let you specify custom layout components to use in your form. There are three types of layouts:

- form layout
- root layout
- group layout for groups of fields so that can be styled together
- buttons layout for 

The form layout actually works like a main group.

```js
settings: {
  form: {
    // you can make it have a default value
  },
  group: {
    // or you can provide a string name of a globally registered component
    layout: 'MyAwesomeGroupLayout'
  },
  buttons: {
    // finally you can provide a component object
    layout: MyAwesomeButtonsLayout
  }
}
```


### Field components

### Field slots

Even if you provide partial data for `Settings`, the rest of properties will still get default values.

Settings let you to provide layout components for different parts of the application, custom options for them (specific to the layout component), change the order of field slots (for example move errors above the label) or set default values of custom options for particular type of fields.