import FormicsForm from './components/FormicsForm.vue'
import FormicsMixin from './mixins/FormicsMixin'
import LayoutMixin from './mixins/LayoutMixin'
import ButtonMixin from './mixins/ButtonMixin'
import FormicsTypes from './types'

// Install the components
const install = function (Vue, Components) {
  Vue.component('FormicsForm', FormicsForm)

  Object.keys(Components).forEach((key) => {
    Vue.component(key, Components[key])
  })
}

const Formics = {
  install
}

export {
  Formics,
  ButtonMixin,
  LayoutMixin,
  FormicsMixin,
  FormicsTypes,
  FormicsForm
}

// Auto-install
if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(Formics)
}
