import CustomMixin from './CustomMixin'
import FunctionsMixin from './FunctionsMixin'

export default {
  mixins: [
    CustomMixin,
    FunctionsMixin
  ],
  props: {
    label: String,
    callback: Function,
    disabled: {
      required: false
    }
  },
  data () {
    return {
      root: true,
      defaults: {}
    }
  },
  methods: {
    // emit an event back to FormicsForm or trigger the callback function if provided
    action () {
      typeof this.callback === 'function' ? this.callback() : this.$emit('click')
    }
  }
}
