export default {
  props: {
    // we're naming this customProp so that we can save custom name for templates
    customProp: {
      type: Object,
      default () {
        return {}
      }
    }
  },
  computed: {
    // custom options for particular field
    custom () {
      let custom = {}
      if (this.root) {
        // custom options for single element
        custom = Object.assign({}, this.defaults, this.functions(this.customProp))
      } else {
        // custom options for multiple elements
        Object.entries(this.defaults || {}).forEach(([key, val]) => {
          custom[key] = Object.assign({}, val, this.functions(this.customProp[key]))
        })
      }
      return custom
    }
  }
}
