import CheckboxMixin from './CheckboxMixin'
import CustomMixin from './CustomMixin'
import EmitMixin from './EmitMixin'
import FunctionsMixin from './FunctionsMixin'
import ModelMixin from './ModelMixin'
import OptionsMixin from './OptionsMixin'
import PasswordMixin from './PasswordMixin'
import TextsMixin from './TextsMixin'
import ValidationMixin from './ValidationMixin'

export default {
  mixins: [
    CheckboxMixin,
    CustomMixin,
    EmitMixin,
    FunctionsMixin,
    ModelMixin,
    OptionsMixin,
    PasswordMixin,
    TextsMixin,
    ValidationMixin
  ],
  props: {
    field: {
      type: Object,
      default () {
        return {}
      }
    },
    settings: Object,
    components: {
      type: Object,
      default () {
        return {}
      }
    },
    schema: Object,
    disabled: Boolean,
    required: Boolean,
    wrapper: {
      type: String,
      default: 'div'
    },
    layout: [String, Object],
    state: String,
    name: {
      type: String,
      required: true
    },
    type: String,
    i18n: Array
  },
  computed: {
    isField () {
      return this.type !== 'group'
    }
  },
  methods: {
    isActive (active) {
      return typeof active === 'undefined' ? true : this.f(active)
    },
    areEqual (left, right) {
      return JSON.stringify(left) === JSON.stringify(right)
    }
  }
}
