export default {
  methods: {
    f (val) {
      return typeof val === 'function' ? val() : val
    },
    // count this.f() for all passed props in an Object
    functions (obj = {}) {
      let props = {}
      for (const [key, val] of Object.entries(obj)) {
        props[key] = this.f(val)
      }
      return props
    },
    // count this.f() for all passed props in an Array
    functionsArray (arr = []) {
      return arr.map(val => {
        return this.f(val)
      })
    }
  }
}
