export default {
  props: {
    // we're calling this optionsProp so that we can save options name for templates
    optionsProp: {
      type: [ Object, Array ],
      default () {
        return {}
      }
    }
  },
  watch: {
    // filters out keys that are not used by schema anymore
    // should it be done for select too? probably not because select options are often dynamic / async
    options () {
      if (this.type === 'checkbox') {
        this.fieldModel = this.options.filter((option) => this.fieldModel.indexOf(option.value) > -1)
      }
    }
  },
  computed: {
    options () {
      let result = []
      let options = this.f(this.optionsProp)
      // array
      if (Array.isArray(options)) {
        console.log('LOL ARRAY: ' + JSON.stringify(options))
        let optionsArray = this.functionsArray(options)
        result = optionsArray.map((val) => {
          // collection
          if (typeof val === 'object') {
            console.log('NYA OBJECT: ' + JSON.stringify(val))
            return Object.assign({}, this.functions(val))
          } else {
            console.log('NYA VALUE: ' + JSON.stringify(val))
            return { text: val, value: val }
          }
        })
      // object
      } else {
        console.log('LOL OBJECT: ' + JSON.stringify(options))
        let optionsObject = this.functions(options)
        result = Object.keys(optionsObject).map((key) => {
          let val = optionsObject[key]
          console.log('optionsProp for label: ' + key + ': ' + val)
          // nested object
          if (typeof val === 'object') {
            return Object.assign({}, this.functions(val), { text: key })
          } else {
            return { value: val, text: key }
          }
        })
      }
      return this.functionsArray(result)
    }
  },
  methods: {
    // bindings for iterated fields like radio, checkbox, switch, select
    getOptionBindings (option, text = 'text', value = 'value') {
      let bindings = Object.assign({}, this.custom.field, option)
      console.log('getOptions before: ' + JSON.stringify(bindings))
      if (text !== 'text') {
        bindings[text] = bindings.text
        delete bindings.text
      }
      if (value !== 'value') {
        bindings[value] = bindings.value
        delete bindings.value
      }
      console.log('getOptions after: ' + JSON.stringify(bindings))
      return bindings
    }
  }
}
