export default {
  props: {
    placeholder: String,
    label: String,
    hint: String
  },
  computed: {
    getLabel () {
      return this.getText('labels', this.label || this.name)
    },
    getPlaceholder () {
      return this.placeholder ? this.getText('placeholders', this.placeholder) : ''
    },
    getHint () {
      return this.hint ? this.getText('hint', this.hint) : ''
    }
  },
  methods: {
    getText (category, text, params) {
      // we declare labels, placeholders and errors separately because this way they're more flexible and reusable across multiple forms
      return this.$i18n ? this.$i18n.t('formics.' + category + '.' + text, params) : text
    }
  }
}
