export default {
  props: {
    validations: {
      type: Object,
      default () {
        return {}
      }
    },
    // is that still needed?
    v: {
      type: Object,
      default () {
        return {}
      }
    },
    messages: {
      type: Object,
      default () {
        return {}
      }
    }
  },
  computed: {
    invalid () {
      return typeof this.$v === 'undefined' ? false : this.$v.$invalid
    }
  },
  watch: {
    $v (val) {
      this.$emit('touch', this.name)
    }
  },
  methods: {
    getErrors (v) {
      let arr = []
      // are there any validation rules
      if (typeof v === 'object') {
        // is any validator invalid
        if (v.$error) {
          for (const [validator, params] of Object.entries(v.$params)) {
            // is validator invalid and not a promise
            if (!v[validator] && !v.$pending) {
              if (this.$i18n) {
                arr.push(this.$i18n.t('formics.validation.' + validator, params))
              } else {
                arr.push(this.messages[validator] || 'error message missing for key: ' + validator)
              }
            }
          }
        }
      }
      // return array of errors or empty array
      return arr
    }
  }
}
